"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _xss = _interopRequireDefault(require("xss"));
var myxss = new _xss["default"].FilterXSS({
  whiteList: {
    a: ['href', 'title', 'target', 'class'],
    u: ['class'],
    br: ['class'],
    b: ['class'],
    i: ['class'],
    ol: ['style', 'class'],
    ul: ['style', 'class'],
    li: ['class'],
    p: ['style', 'class'],
    sub: ['class'],
    sup: ['class'],
    div: ['style', 'class'],
    em: ['class'],
    strong: ['class'],
    span: ['style', 'class'],
    ins: ['class']
  }
});
var _default = exports["default"] = myxss;